function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

var QueryMeter = /*#__PURE__*/function (_Component) {
  _inheritsLoose(QueryMeter, _Component);

  function QueryMeter(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      degrees: 0,
      percentage: 0,
      roundedPercentage: 0,
      maxHits: 0,
      totalHits: 0,
      style: _this.getStyles(_this.props)
    };
    return _this;
  }

  var _proto = QueryMeter.prototype;

  _proto.getStyles = function getStyles(props) {
    var styles = {
      container: {
        overflow: "hidden",
        padding: props.containerSpacing || 0,
        display: "inline-flex",
        flexDirection: "column",
        position: "relative",
        background: props.containerBackgroundColor,
        borderRadius: props.width * 2 + "px " + props.width * 2 + "px 0 0",
        minHeight: !props.showPercentage ? props.width / 2 - props.containerSpacing + "px" : props.width / 2 + "px",
        maxHeight: !props.showPercentage ? props.width / 2 - props.containerSpacing + "px" : props.width / 2 + "px"
      },
      wrapper: {
        width: props.width,
        minHeight: props.width / 2,
        maxHeight: props.width / 2,
        position: "relative",
        borderRadius: props.width * 2 + "px " + props.width * 2 + "px 0 0"
      },
      bottomLayer: {
        position: "absolute",
        top: 0,
        left: 0,
        background: props.fillBackgroundColor,
        borderRadius: props.width * 2 + "px " + props.width * 2 + "px 0 0",
        width: props.width,
        height: props.width / 2,
        zIndex: 1
      },
      colorLayer: {
        position: "absolute",
        top: props.width / 2,
        left: 0,
        background: props.fillColor,
        borderRadius: "0 0 " + props.width * 2 + "px " + props.width * 2 + "px",
        width: props.width,
        height: props.width / 2,
        zIndex: 2,
        transformOrigin: "50% 0%",
        transitionTimingFunction: props.transitionTiming,
        transitionProperty: "all",
        transitionDuration: props.duration + "ms"
      },
      coverLayer: {
        position: "absolute",
        bottom: 0,
        left: "50%",
        background: props.coverBackgroundColor,
        borderRadius: props.width * 2 + "px " + props.width * 2 + "px 0 0",
        width: props.width - props.thickness * 2,
        height: props.width / 2 - props.thickness,
        transform: "translate(-50%, 0)",
        zIndex: 4
      },
      bottomCoverLayer: {
        height: props.containerSpacing,
        background: props.containerBackgroundColor,
        position: "absolute",
        bottom: 0,
        left: 0,
        right: 0,
        margin: "0 " + props.containerSpacing + "px",
        zIndex: 2,
        display: props.showPercentage ? "block" : "none"
      },
      seperator: {
        position: "absolute",
        bottom: 0 - props.sliceGap / 2,
        left: "-2px",
        width: 2 + props.width / 2,
        height: props.sliceGap,
        zIndex: 3,
        overflow: "hidden",
        transformOrigin: "100% 50% 0px",
        background: props.coverBackgroundColor
      },
      percentage: {
        transform: "rotate(-90deg)",
        position: "absolute",
        top: 0,
        width: 40,
        left: -36,
        fontSize: 12,
        textAlign: "center",
        transformOrigin: "50% 0% 0px",
        cursor: "default"
      },
      detailsContainer: {
        flex: 1,
        height: "100%",
        flexDirection: "column",
        justifyContent: "center",
        alignItems: "center",
        display: "flex",
        fontSize: 12,
        paddingTop: 7
      },
      labelText: {
        fontSize: 13,
        color: "#4e4e4e"
      },
      labelNumber: {
        fontWeight: 800,
        fontSize: 13,
        color: "#4e4e4e"
      }
    };
    return styles;
  };

  _proto.refresh = function refresh(props) {
    if (this.isUnmounted) return;
    var style = this.getStyles(props);
    var maxHits = props.maxHits;
    var strengthMode = props.strengthMode;
    var totalHits = props.totalHits || 0;
    var percentage = totalHits === 1 ? 100 : totalHits === 0 ? 0 : strengthMode ? 100 - totalHits / maxHits * 100 : totalHits / maxHits * 100;
    if (percentage < 0 || !percentage) percentage = 0;
    var roundedPercentage = Math.floor(percentage);
    if (props.getPercentage) props.getPercentage(roundedPercentage);
    var degrees = 180 * roundedPercentage / 100;
    this.setState({
      percentage: percentage,
      roundedPercentage: roundedPercentage,
      degrees: degrees,
      maxHits: maxHits,
      totalHits: totalHits,
      style: style
    });
  };

  _proto.componentDidMount = function componentDidMount() {
    var arrayOfnumbersToAnimate = [];

    if (this.props.showInfo) {
      arrayOfnumbersToAnimate.push({
        element: this.refs.totalHits,
        state: "totalHits",
        previous: 0,
        current: 0
      }, {
        element: this.refs.maxHits,
        state: "maxHits",
        previous: 0,
        current: 0
      });
    }

    if (this.props.showPercentage) {
      arrayOfnumbersToAnimate.push({
        element: this.refs.percentage,
        state: "percentage",
        previous: 0,
        current: 0
      });
    }

    this.initElementsOfNumbers(arrayOfnumbersToAnimate);
    this.refresh(this.props);
    this.animateNumbers(arrayOfnumbersToAnimate);
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    var conditionalProps = ["topText", "bottomText"];

    for (var i = 0; i < conditionalProps.length; i++) {
      if (this.props[conditionalProps[i]] !== nextProps[conditionalProps[i]]) return true;
    }

    var conditionalState = ["maxHits", "totalHits", "degrees"];

    for (var _i = 0; _i < conditionalState.length; _i++) {
      if (nextProps[conditionalState[_i]] !== nextState[conditionalState[_i]]) return true;
    }

    return false;
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (prevProps !== this.props) {
      this.refresh(this.props);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.isUnmounted = true;
  };

  _proto.initElementsOfNumbers = function initElementsOfNumbers(arrayOfnumbersToAnimate) {
    var _this2 = this;

    arrayOfnumbersToAnimate.forEach(function (obj) {
      obj.element.innerHTML = obj.current.toLocaleString();
      obj.next = _this2.state[obj.state];
      obj.startTime = Date.now();
    });
  };

  _proto.animateNumbers = function animateNumbers(array) {
    var _this3 = this;

    var myReq;

    var step = function step(timestamp) {
      array.forEach(function (obj) {
        if (obj.next !== _this3.state[obj.state]) {
          if (obj.previous === _this3.state[obj.state]) {
            var span = obj.next - obj.previous;
            var position = span ? (obj.next - obj.current || span) / span : 0;
            obj.startTime = Date.now() - _this3.props.duration * position;
            obj.previous = obj.next;
            obj.next = _this3.state[obj.state];
          } else {
              obj.startTime = Date.now();
              obj.previous = obj.current;
              obj.next = _this3.state[obj.state];
            }
        }

        if (obj.current == obj.next) {
          obj.startTime = Date.now();
          obj.previous = obj.next;
          return;
        }

        var timespan = Date.now() - obj.startTime;
        var positionInTime = Math.min(timespan / (_this3.props.duration || timespan), 1);
        var progress = (obj.next - obj.previous) * positionInTime;
        obj.current = obj.previous + progress;
        obj.element.innerHTML = Math.round(obj.current).toLocaleString();
      });
      myReq = window.requestAnimationFrame(step);
    };

    myReq = window.requestAnimationFrame(step);
  };

  _proto.renderSlices = function renderSlices() {
    var arrayOfSlices = [];

    for (var i = 1; i < this.props.slices; i++) {
      arrayOfSlices.push( /*#__PURE__*/React__default.createElement("div", {
        key: i,
        style: _extends({}, this.state.style.seperator, {
          transform: "rotate(" + 180 / this.props.slices * i + "deg)"
        })
      }));
    }

    return arrayOfSlices;
  };

  _proto.renderPercentage = function renderPercentage() {
    if (!this.props.showPercentage) return;
    return /*#__PURE__*/React__default.createElement("div", {
      "data-auto": "percentage",
      style: _extends({}, this.state.style.percentage, this.props.percentageStyle),
      title: this.state.percentage + "%"
    }, /*#__PURE__*/React__default.createElement("span", {
      ref: "percentage"
    }), "%");
  };

  _proto.renderInfo = function renderInfo() {
    if (!this.props.showInfo) return;
    return /*#__PURE__*/React__default.createElement("div", {
      style: _extends({}, this.state.style.detailsContainer, this.props.infoContainerStyle)
    }, /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: "flex",
        alignItems: "baseline"
      }
    }, /*#__PURE__*/React__default.createElement("span", {
      "data-auto": "selected-entity-type",
      style: _extends({}, this.state.style.labelText, this.props.infoTextStyle, {
        textAlign: "center"
      })
    }, this.props.topText), /*#__PURE__*/React__default.createElement("span", {
      "data-auto": "hits",
      ref: "totalHits",
      style: _extends({}, this.state.style.labelNumber, this.props.infoNumbersStyle)
    })), /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: "flex",
        alignItems: "baseline"
      }
    }, /*#__PURE__*/React__default.createElement("span", {
      style: _extends({}, this.state.style.labelText, this.props.infoTextStyle)
    }, this.props.bottomText), /*#__PURE__*/React__default.createElement("span", {
      "data-auto": "all-from-type",
      ref: "maxHits",
      style: _extends({}, this.state.style.labelNumber, this.props.infoNumbersStyle)
    })));
  };

  _proto.render = function render() {
    return /*#__PURE__*/React__default.createElement("div", {
      style: this.state.style.container
    }, /*#__PURE__*/React__default.createElement("div", {
      style: this.state.style.wrapper
    }, /*#__PURE__*/React__default.createElement("div", {
      style: this.state.style.bottomLayer
    }), /*#__PURE__*/React__default.createElement("div", {
      style: _extends({}, this.state.style.colorLayer, {
        transform: "rotate(" + this.state.degrees + "deg)"
      })
    }, this.renderPercentage()), /*#__PURE__*/React__default.createElement("div", {
      style: this.state.style.coverLayer
    }, this.renderInfo()), /*#__PURE__*/React__default.createElement("div", null, this.renderSlices())), /*#__PURE__*/React__default.createElement("div", {
      style: this.state.style.bottomCoverLayer
    }));
  };

  return QueryMeter;
}(React.Component);

QueryMeter.defaultProps = {
  width: 200,
  thickness: 25,
  slices: 6,
  sliceGap: 2,
  duration: 1000,
  transitionTimingFunction: "ease-in-out",
  coverBackgroundColor: "#fff",
  containerBackgroundColor: "#fff",
  fillColor: "radial-gradient(circle, rgba(63,94,251,1) 0%, rgba(252,70,107,1) 100%)",
  fillBackgroundColor: "#eee",
  containerSpacing: 20,
  strengthMode: true,
  percentageStyle: {},
  infoNumbersStyle: {},
  infoTextStyle: {},
  showInfo: true,
  showPercentage: true,
  topText: "Total Hits: ",
  bottomText: "Max Hits: ",
  firstAnimationDelay: 0,
  totalHits: 400,
  maxHits: 1000
};

module.exports = QueryMeter;
//# sourceMappingURL=index.js.map
